//---------------------------------------------------------------------------
//        .
//          .
// *********************************************
//   ZUML (ZU macro language):
//      zu.exe
// *********************************************
//   /   
//     -    
//       
//          
//        
// ,      Faza    
//    
//  ,      
//           
//            
// *********************************************
//  :
//     .
//   "//"       , ..   .
//   -  .
//   "MACRO _"
//       "FAZA"  ,    .
//     FAZA  FAZA  FAZA  END     .
// END -  .     .
// *********************************************
//  :
// :
// MACRO -  ,       .
// FAZA -    -              .
// END -  .

//   :
// 0 SFI_TIME - (stop faza if)     
// 1 SFI_DP - (stop faza if)     
// 2 SFI_I - (stop faza if)       
// 3 SFI_V - (stop faza if)       
// 4 SFI_T - (stop faza if)       
// 5 SFI_TC - (stop faza if)        
// 6 SFI_UI - (stop faza if)        
// 7 SFI_UV - (stop faza if)        
// 8 SFI_UT - (stop faza if)        

//    :
// 9 SCI - (set charge I)    
// 10 SCV - (set charge V)    
// 11 SDI - (set discharge I)    
// 12 SDV - (set discharge V)    

//    :
// 13 SII_V - (set charge I if)       ...
// 14 SDII_V - (set discharge I if)       ...
// 15 SII_T - (set charge I if)       ...
// 16 SDII_T - (set discharge I if)       ...

// 17 RII_V - (reset charge I if)       ...
// 18 RDII_V - (reset discharge I if)       ...
// 19 RII_T - (reset charge I if)       ...
// 20 RDII_T - (reset discharge I if)       ...

//     b0, b1, b2, b3, b4      ( 31 .)
//  b5     =0(<) +0, =1(>) +32

// :
// -------------------------------------------------------------------------------------
//   NiMh
// -------------------------------------------------------------------------------------
/*
MACRO NiMh_8s_2Ah_full_charge
SFI_T>60       //      
SFI_UT>2       //        
// -------------------------------------------------------------------------------------
FAZA           //       
  SCI=0.05     //   
  SFI_TIME=10  //       
  SFI_V>8      //      V
// -------------------------------------------------------------------------------------
FAZA           //  
  SCI=0.45     //   
  SFI_TIME=180 //       
  SFI_DP>0.1   //      
// -------------------------------------------------------------------------------------
END            //  
*/
//---------------------------------------------------------------------------
String MW[21]={"SFI_TIME", "SFI_DP", "SFI_I", "SFI_V", "SFI_T", "SFI_TC", "SFI_UI", "SFI_UV", "SFI_UT",
			   "SCI", "SCV", "SDI", "SDV",
			   "SII_V", "SDII_V", "SII_T", "SDII_T",
			   "RII_V", "RDII_V", "RII_T", "RDII_T"};
//---------------------------------------------------------------------------
//          
// x -  
// iv - false=  , true=  
// cd - false=, true=
void MGO(sCH &ch, bool iv, bool cd, double f)
{
ch.fCD=cd;
ch.fIV=iv;
if(iv){ch.VV=f; ch.II=0;}else{ch.VV=0; ch.II=f;}
StartCh(ch);
ReShowAll();
}
//---------------------------------------------------------------------------
String FF(double a){return(FormatFloat("0.00", a));}
//---------------------------------------------------------------------------
//    
bool TestM(sCH &ch, BYTE c, float f)
{
bool ff=false;							//   
String rez;                        		//        
bool fc;                                //    (fc=true,  )
										//						(fc=false,  )
if(c>=32){c-=32; fc=true;}              //      
else fc=false;

float t;
double Vmax, V, I, T, Tc, UI, UV, UT, cIC, cID;
t=(double(Now())-ch.TimeStartF)*24*60; //     
Vmax=ch.Vmax;
cIC=ch.cIC;
cID=ch.cID;
if(ch.iP>0)
  {
  V=ch.V[ch.iP-1];
  I=ch.I[ch.iP-1];
  T=ch.T[ch.iP-1];
  Tc=ch.Tc[ch.iP-1];
  UV=ch.UV[ch.iP-1];
  UI=ch.UI[ch.iP-1];
  UT=ch.UT[ch.iP-1];
  }
else V=I=T=Tc=UV=UI=UT=0;

switch(c)
  {
  case 0:	// SFI_TIME     
	rez="SFI_TIME("+FormatFloat("0.00", t)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (t>f)){ff=true; break;}
	if(!fc && (t<f)){ff=true; break;}
	break;
  case 1:   // SFI_DP   
	rez="SFI_DP("+FormatFloat("0.00", Vmax-V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && Vmax-V>f && t>10){ff=true; break;} //   10   
	if(!fc){ff=true; break;}						//    
	break;
  case 2:   // SFI_I  .
	rez="SFI_I("+FormatFloat("0.00", I)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (I>f)){ff=true; break;}
	if(!fc && (I<f)){ff=true; break;}
	break;
  case 3:   // SFI_V  .
	rez="SFI_V("+FormatFloat("0.00", V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (V>f)){ff=true; break;}
	if(!fc && (V<f)){ff=true; break;}
	break;
  case 4:   // SFI_T  .
	rez="SFI_T("+FormatFloat("0.00", T)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (T>f)){ff=true; break;}
	if(!fc && (T<f)){ff=true; break;}
	break;
  case 5:   // SFI_TC   .
	rez="SFI_TC("+FormatFloat("0.00", Tc)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (Tc>f)){ff=true; break;}
	if(!fc && (Tc<f)){ff=true; break;}
	break;
  case 6:   // SFI_UI    .
	rez="SFI_UI("+FormatFloat("0.00", UI)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (UI>f)){ff=true; break;}
	if(!fc && (UI<f)){ff=true; break;}
	break;
  case 7:   // SFI_UV    .
	rez="SFI_UV("+FormatFloat("0.00", UV)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (UV>f)){ff=true; break;}
	if(!fc && (UV<f)){ff=true; break;}
	break;
  case 8:   // SFI_UT    .
	rez="SFI_UT("+FormatFloat("0.00", UT)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (UT>f)){ff=true; break;}
	if(!fc && (UT<f)){ff=true; break;}
	break;
  case 9:   // SCI    
	rez="SCI("+FormatFloat("0.00", I)+")="+FormatFloat("0.00", f);
	if(fabs(I-f)>0.01)MGO(ch, false, false, f);
	ch.cIC=f; ch.cID=0;
	break;
  case 10:  // SCV    
	rez="SCV("+FormatFloat("0.00", V)+")="+FormatFloat("0.00", f);
	if(fabs(V-f)>0.01)MGO(ch, true, false, f);
	break;
  case 11:  // SDI    
	rez="SDI("+FormatFloat("0.00", I)+")="+FormatFloat("0.00", f);
	if(fabs(I-f)>0.01)MGO(ch, false, true, f);
	ch.cID=f; ch.cIC=0;
	break;
  case 12:  // SDV    
	rez="SDV("+FormatFloat("0.00", V)+")="+FormatFloat("0.00", f);
	if(fabs(V-f)>0.01)MGO(ch, true, true, f);
	break;
  case 13:  // SII_V       ...
	rez="SII_V("+FormatFloat("0.00", V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (V>f))MGO(ch, false, false, cIC);
	if(!fc && (V<f))MGO(ch, false, false, cIC);
	break;
  case 14:  // SDII_V       ...
	rez="SDII_V("+FormatFloat("0.00", V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (V>f))MGO(ch, false, true, cID);
	if(!fc && (V<f))MGO(ch, false, true, cID);
	break;
  case 15:  // SII_T       ...
	rez="SII_T("+FormatFloat("0.00", T)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (T>f))MGO(ch, false, false, cIC);
	if(!fc && (T<f))MGO(ch, false, false, cIC);
	break;
  case 16:  // CDII_T       ...
	rez="CDII_T("+FormatFloat("0.00", T)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (T>f))MGO(ch, false, true, cID);
	if(!fc && (T<f))MGO(ch, false, true, cID);
	break;
  case 17:  // RII_V       ...
	rez="RII_V("+FormatFloat("0.00", V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (V>f))MGO(ch, false, false, 0);
	if(!fc && (V<f))MGO(ch, false, false, 0);
	break;
  case 18:  // RDII_V       ...
	rez="RDII_V("+FormatFloat("0.00", V)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (V>f))MGO(ch, false, true, 0);
	if(!fc && (V<f))MGO(ch, false, true, 0);
	break;
  case 19:  // RII_T       ...
	rez="RII_T("+FormatFloat("0.00", T)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (T>f))MGO(ch, false, false, 0);
	if(!fc && (T<f))MGO(ch, false, false, 0);
	break;
  case 20:  // RDII_T       ...
	rez="RDII_T("+FormatFloat("0.00", T)+")"+(fc?">":"<")+FormatFloat("0.00", f);
	if(fc  && (T>f))MGO(ch, false, true, 0);
	if(!fc && (T<f))MGO(ch, false, true, 0);
	break;
  }
ch.Hint+=String(rez)+"\n";
if(ff){LogAkk(ch.tg, rez); return(true);}
return(false);
}
//---------------------------------------------------------------------------
//  
//     ,     
void ZUML(sCH &ch)
{
int j, n=0;
if(ch.iMAC==0)return;				//    
for(int i=0; i<ch.iMAC; i+=0)       //    
  {
  if(ch.MAC[i]==0xff){n++; i++; if(i==ch.cMAC)break;}
  else{i+=1+sizeof(float);}
  }
ch.Hint="";
ch.Hint+=": "+IntToStr(n)+"\n"; //   
ch.Hint+=" :\n";
//  ,    
for(int i=0; i<ch.iMAC; i+=1+sizeof(float))
  {
  if(ch.MAC[i]==0xff)break; //   1  -   
  if(TestM(ch, ch.MAC[i], *((float*)(&(ch.MAC[i+1])))))		//    
	{       //       , .  
	StopCh(ch);       //  
	return;
	}
  }
ch.Hint+=" :\n";
//  ,    
for(int i=ch.cMAC; i<ch.iMAC; i+=1+sizeof(float))
  {                         //      
  if(ch.MAC[i]==0xff)break; //     -  
  if(TestM(ch, ch.MAC[i], *((float*)(&(ch.MAC[i+1])))))		//       
	{       //       , .   
	for(j=ch.cMAC; j<ch.iMAC; j+=1+sizeof(float))			//    
	  if(ch.MAC[j]==0xff)    //    
		{
		if(j+1>=ch.iMAC)     //      (  )
		  {
		  StopCh(ch);       //  
		  return;
		  }
		ch.cMAC=j+1;        //     
		ch.cIC=ch.cID=0;   //          
		ch.TimeStartF=Now(); //     
		return;
		}
	if(j>=ch.iMAC)	    //          ,   
	  {
	  StopCh(ch);       //  
	  return;
	  }
	}
  }
}
//---------------------------------------------------------------------------
//   (   )
void LoadMacro(sCH &ch)
{
BYTE c=0;
int j;
String S, S1, S2;
bool fStart=false;
bool fSymb;
TRichEdit *tr;
tr=FormM->RichEdit1;
ch.iMAC=ch.cMAC=ch.cIC=ch.cID=0;
for(int i=0; i<tr->Lines->Count; i++)
  {
  if(ch.iMAC>1990){ShowMessage("  !!!"); ch.iMAC=0; return;}
  S=tr->Lines->Strings[i];
  if(S.Pos("MACRO")>0){fStart=true; continue;}  //       
  if(S.Pos("END")>0)return;                     //   ,  
  if(S.Pos("FAZA")>0)                           //   
	{
	if(c==0xff){ShowMessage("   "+IntToStr(i+1)+".   !!!"); ch.iMAC=0; return;}
	ch.MAC[ch.iMAC++]=0xff;
	c=0xff;
	if(ch.cMAC==0)ch.cMAC=ch.iMAC;              //   ,       
	continue;
	}
  if(fStart)                                    //    
	{
	S=GetPrm(S, 0, '/').Trim();                 //  
	if(S.IsEmpty())continue;                    //   
	if(S.Pos("<")){fSymb=false; S1=GetPrm(S, 0, '<'); S2=GetPrm(S, 1, '<');}
	if(S.Pos(">")){fSymb=true; S1=GetPrm(S, 0, '>'); S2=GetPrm(S, 1, '>');}
	if(S.Pos("=")){fSymb=true; S1=GetPrm(S, 0, '='); S2=GetPrm(S, 1, '=');}  // "="   ">"
	for(j=0; j<21; j++)
	  if(String(S1)==MW[j])
		{
		c=j;
		if(fSymb)c+=32;
		ch.MAC[ch.iMAC++]=c;                          //  
		float f=ToDouble(S2);
		*((float*)(&(ch.MAC[ch.iMAC])))=f;            //   float
		ch.iMAC+=sizeof(float);
		if(tdError){ShowMessage("   "+IntToStr(i+1)+".   "+S2+"!!!"); ch.iMAC=0; return;}
		break;
		}
	if(j==21){ShowMessage("   "+IntToStr(i+1)+".   "+S1+"!!!"); ch.iMAC=0; return;}
	}
  }
}
//---------------------------------------------------------------------------
void Pnt(TRichEdit *r, int n, int i, TColor t)
{
r->SelStart=n; r->SelLength=i; r->SelAttributes->Color=t;
}
//---------------------------------------------------------------------------
//   -
void ReText(TRichEdit *r)
{
r->Enabled=false;
int n=0;
long x, y, s, l;
x=r->CaretPos.x;    //   
y=r->CaretPos.y;    //   
s=r->SelStart;		//    
l=r->SelLength;		//    

for(int i=0; i<r->Lines->Count; i++)
  {
  String S, SS=r->Lines->Strings[i];
  int K=SS.Pos("//");
  int LSS=SS.Length();
  S=String(SS);
  int LS=S.Length();
  Pnt(r, n, LSS, clBlack);
  if(K>0){S=SS.SubString(1, K-1); LS=S.Length(); Pnt(r, n+K-1, LSS-LS, clGreen);}
  int R=S.Pos("=");
  int R1=S.Pos("<");
  int R2=S.Pos(">");
  if(R+R1+R2>0)
	{
	Pnt(r, n, R+R1+R2-1, clFuchsia);
	Pnt(r, n+R+R1+R2-1, 1, clBlack);
	Pnt(r, n+R+R1+R2, LS-(R+R1+R2), clBlue);
	}
  else
	{
	int f1=S.Pos("MACRO"); if(f1>0){Pnt(r, n+f1-1, 5, clRed); Pnt(r, n+f1+4, LS-(f1+4), clBlue);}
	int f2=S.Pos("FAZA"); if(f2>0){Pnt(r, n+f2-1, 4, clRed);}
	int f3=S.Pos("END"); if(f3>0){Pnt(r, n+f3-1, 3, clRed);}
	}
  n+=r->Lines->Strings[i].Length()+1;
  }
r->CaretPos.x=x;    //   
r->CaretPos.y=y;    //   
r->SelStart=s;      //  
r->SelLength=l;     //  
r->Enabled=true;
}
//---------------------------------------------------------------------------

