//---------------------------------------------------------------------------
//       RS232
//     
//     RS232     
//   
//---------------------------------------------------------------------------
//    :
// 1.  8.
// 2.   1.
// 3.   .
// 4.   (  )
// 5.    =   10()  
// 6.    =   50      
// 7.     1 
//     7.1  (1 )
//     7.2 
//     7.3 
//     7.4 
//     7.5   (1 )
// 8.      1  ( , , CRC)
//     8.1  , !
//     8.2    (1 )
//     8.3  (x )
//     8.4   (1 )
//        ..\MicroProg\uart_in.cpp
//---------------------------------------------------------------------------
#define PWM1TOP  0x1FFF             //    1  (1   2 ) ( 13 )
//  
#define U_NotAnderstand 0xF0        //    (    )
#define U_OK            0xE1        //   
#define U_CANCEL        0xD2        //   
#define U_UP            0xC3        //      
#define U_DOWN          0xB4        //      
#define U_GiveMeADC     0xA5        //    ADC
#define U_GiveMeScr     0x96        //    
#define U_ReadMemory    0x5A        //    
#define U_WriteMemory   0x4B        //  
#define U_GO            0x3C        //  / 
#define U_VAR           0x2D        //  
#define U_Set           0x1F        //  
//---------------------------------------------------------------------------
int COM;						//  COM-  
HANDLE ComHandle=NULL;          //    COM 
bool fComOpend=false;           //   COM-
int COMSpeed;                   //  COM-
_DCB dcb, dcbold;               //  COM-   
_COMMTIMEOUTS to, toold;        //       COM   
bool fOnLine=false;             //  "      COM"
								//       
BYTE InBuf[200];                //      COM
BYTE iInBuf;                    //   
BYTE OutBuf[200];               //     COM
BYTE iOutBuf;                   //   
long strIN=0, strOUT=0, strERR=0; //  // 
//---------------------------------------------------------------------------
String NameTG;                  //      COM-
FILE *TG;						//      COM-
//---------------------------------------------------------------------------
#define POLYNOM_8       0x18    //    8  CRC
#define POLYNOM_16      0xA001  //    16  CRC
//---------------------------------------------------------------------------
//     
void Msg(String a)
{
fprintf(TG, "%s\n", a.c_str());
}
//---------------------------------------------------------------------------
// 8-   
void CRC8(BYTE in, BYTE &crc)
{
for(BYTE i=0; i<8; i++)
  {
  if((in^crc)&0x01){crc=((crc^POLYNOM_8)>>1)|0x80; in=(in>>1)|0x80;}
  else {in>>=1; crc>>=1;}
  }
}
//---------------------------------------------------------------------------
// 16-n   
void CRC16(BYTE in, WORD &crc)
{
crc^=(WORD)in;
for(BYTE i=0; i<8; i++)crc=(crc&0x0001)?(crc>>1)^POLYNOM_16:(crc>>1);
}
//---------------------------------------------------------------------------
//  8     Sr  len
BYTE CrcBuf8(BYTE *Sr, BYTE len)
{
BYTE r=0xff;
for(BYTE i=0; i<len; i++)CRC8(Sr[i], r);
return(r);
}
//---------------------------------------------------------------------------
//  16     Sr   first  len
WORD CrcBuf16(BYTE *Sr, WORD first, WORD len)
{
WORD r=0xffff;
for(WORD i=first; i<first+len; i++)CRC16(Sr[i], r);
return(r);
}
//---------------------------------------------------------------------------
//      
bool CheckInBuf(void)
{
BYTE crc=0xff;
for(BYTE i=0; i<iInBuf-1; i++)CRC8(InBuf[i], crc);
return(crc==InBuf[iInBuf-1]);
}
//---------------------------------------------------------------------------
String HexToStr(WORD x);
//             
int BufLen(int c)
{
switch(c)
  {
  case U_OK:               //    
  case U_CANCEL:           //    Cancel
  case U_UP:               //    Up
  case U_DOWN:             //    Down
  case U_GiveMeScr:        //     
	return(83);            //     , 20*4  , ,  
  case U_GiveMeADC:        //   
	return(25);            //   +16+ 
  case U_NotAnderstand:    //       
	return(1);
  case U_GO:               //   
  case U_WriteMemory:      //   
	return(2);             //       
  case U_ReadMemory:       //   
	return(OutBuf[3]+5);   //    ,     
  case U_VAR:              //     
	return(7);             //    ,  , 4      
  case U_Set:              //    
	return(2);             //       
  }
return(0);
}
//---------------------------------------------------------------------------
//  COM-
bool CloseCOM(void)
{
if(!fComOpend)return(false);          //  COM-  ,    
SetCommState(ComHandle, &dcbold);     //    COM-
SetCommTimeouts(ComHandle, &toold);   //   
CloseHandle(ComHandle);               //  COM-
fComOpend=false;                      //  
strIN=strOUT=strERR=0;				  //  
return(true);                         //  
}
//---------------------------------------------------------------------------
//  COM-
bool OpenCOM(int nCom, int boud)
{
if(boud==0 || nCom<1)return(false);	  //   
if(fComOpend)return(false);           //  COM-   ,    
ComHandle=CreateFile(String("COM"+IntToStr(nCom)).c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
if(ComHandle==INVALID_HANDLE_VALUE)   //  COM-  
  {
  ShowMessage("   COM"+IntToStr(nCom)+"!"); // 
  ComHandle=NULL;
  return(false);
  }
fComOpend=true;                       //   
if(!GetCommState(ComHandle, &dcbold))ShowMessage("  DCB COM"+IntToStr(nCom)+"!\n\n ,  !");
if(!GetCommTimeouts(ComHandle, &toold))ShowMessage("  TimeOuts COM"+IntToStr(nCom)+"!\n\n ,  !");
									  //    COM-  
BuildCommDCBAndTimeouts(("baud="+String(boud)+" parity=N data=8 stop=1 to=on").c_str(), &dcb, &to);
dcb.fBinary=1;                        //     
if(!SetCommState(ComHandle, &dcb))    //   
  {                                   //   , 
  ShowMessage("     (DCB).\n\n    .");
  CloseCOM();                         //   
  return(false);
  }
to.ReadIntervalTimeout=8000/boud+20;   //      (    )
Msg(String("to.ReadIntervalTimeout=")+IntToStr(int(to.ReadIntervalTimeout))); // 
to.ReadTotalTimeoutMultiplier=16000/boud+20; //              
Msg("to.ReadTotalTimeoutMultiplier="+IntToStr(int(to.ReadTotalTimeoutMultiplier))); // 
to.ReadTotalTimeoutConstant=to.WriteTotalTimeoutMultiplier=to.WriteTotalTimeoutConstant=0; //   
if(!SetCommTimeouts(ComHandle, &to)) //    COM-
  {                                  //    
  ShowMessage("    .\n\n    .");
  CloseCOM();                        //  COM-
  return(false);
  }
strIN=strOUT=strERR=0;				 //  
return(true);                        //  
}
//---------------------------------------------------------------------------
String IntToHex(WORD x);
//       - 
void SC(void)
{
try                                                   //   
  {
  String s;
  DWORD r, m;
  PurgeComm(ComHandle, PURGE_TXCLEAR|PURGE_RXCLEAR);  //   COM-
  s="Send ("+IntToHex(iOutBuf)+")";                   //  
  for(BYTE i=0; i<iOutBuf; i++)s+=" "+IntToHex(OutBuf[i]);
  Msg(s);                                             //    
  for(int i=0; i<110; i++)InBuf[i]=0;
  WriteFile(ComHandle, OutBuf, iOutBuf, &r, NULL);    //    COM-
//  SetCommMask(ComHandle, EV_RXCHAR);                //    "     "
//  WaitCommEvent(ComHandle, &m, NULL);               //     
  for(int i=0; i<30; i++)
	{
	ReadFile(ComHandle, InBuf, BufLen(OutBuf[0]), &m, NULL);  //      
	if(InBuf[0]!=0)break;
	}
  iInBuf=BufLen(InBuf[0]);                            //      
  s="Receive ("+IntToHex(iInBuf)+") ";                // 
  for(BYTE i=0; i<iInBuf; i++)s+=" "+IntToHex(InBuf[i]);
  Msg(s);                                             //    
  if(iInBuf!=int(m))Msg(" "+IntToStr(BufLen(OutBuf[0]))+"  "+IntToStr(int(m)));
  }
catch(...)                                            //     
  {
  Msg("    !!!");
  }
}
//---------------------------------------------------------------------------
//      
//     
//       
bool SendCommandToCOM(void)
{
if(!fComOpend)return(false);
int iErr=0;                     //  
switch(OutBuf[0])
  {
  case U_NotAnderstand:
	Msg("U_NotAnderstand:    (    )");
	break;
  case U_OK:
	Msg("U_OK:   ");
	break;
  case U_CANCEL:
	Msg("U_CANCEL:   ");
	break;
  case U_UP:
	Msg("U_UP:      ");
	break;
  case U_DOWN:
	Msg("U_DOWN:      ");
	break;
  case U_GiveMeADC:
	Msg("U_GiveMeADC:    ADC");
	break;
  case U_GiveMeScr:
	Msg("U_GiveMeScr:    ");
	break;
  case U_ReadMemory:
	Msg("U_ReadMemory:     :"+HexToStr((WORD(OutBuf[2])<<8)+WORD(OutBuf[1]))+" :"+IntToStr(OutBuf[3]));
	break;
  case U_WriteMemory:
	Msg("U_WriteMemory:   :"+HexToStr((WORD(OutBuf[2])<<8)+WORD(OutBuf[1]))+" :"+IntToStr(OutBuf[3]));
	break;
  case U_GO:
	Msg("U_GO:  / :"+IntToStr(OutBuf[1])+"  #"+IntToStr((OutBuf[2]>>7)+1));
	break;
  case U_VAR:
	Msg("U_VAR:   :"+IntToStr(OutBuf[1]));
	break;
  case U_Set:
	Msg("U_Set:   Test#"+IntToStr((OutBuf[1]>>7)+1)+" :"+HexToStr((WORD(OutBuf[4])<<8)+WORD(OutBuf[3])));
	break;
  }
do{                             //  
  iErr++;                       //   
  if(iErr>1)strERR++;
  if(iErr>3){Msg("      3 !!!"); return(false);}
  if(!fComOpend)break;          //  COM-  , 
  SC();                         //     
  strIN+=iInBuf;  				//    
  strOUT+=iOutBuf;				//    
  if(iInBuf<2)continue;         //     ,   " "
  if(!CheckInBuf())continue;    //     
  break;                        //        
  }while(true);
return(true);
}
//---------------------------------------------------------------------------

