//---------------------------------------------------------------------------
//   (, ,    ?,   ?)
bool UCopyFile(String Source, String Target, bool Rem, bool Over)
{
if(!FileExists(Source))return(false);             //   , 
if(FileExists(Target) && !Over)return(true);      //        - 
if(FileExists(Target))DeleteFile(Target);         //   
if(!CopyFile(Source.c_str(), Target.c_str(), false))return(false);//  
if(Rem)DeleteFile(Source);
return(true);
}
//---------------------------------------------------------------------------
//   (, ,    ?,   ?)
bool UCopyFiles(String Source, String Target, bool Rem, bool Over)
{
struct ffblk ffblk;
int done;
String From=ExtractFilePath(Source);
String Mask=ExtractFileName(Source);
String To=ExtractFilePath(Target);
done=chdir(From.c_str());
if(done!=0)return(false);
done=findfirst(Mask.c_str(),&ffblk,0);
while(!done)
  {
  UCopyFile(From+ffblk.ff_name, To+ffblk.ff_name, Rem, Over);
  done=findnext(&ffblk);
  }
return(true);
}
//---------------------------------------------------------------------------
//        
void URunProg(const String Command, const String WorkDir, bool WaitEnd)
{
STARTUPINFO si;
PROCESS_INFORMATION pi;

memset(&si, 0, sizeof(STARTUPINFO));
memset(&pi, 0, sizeof(PROCESS_INFORMATION));
si.cb=sizeof(STARTUPINFO);
si.dwFlags=NULL;
si.wShowWindow=SW_SHOW;
si.hStdOutput=NULL;
si.hStdError=NULL;

if(CreateProcess(NULL, Command.c_str(), NULL, NULL, false, NULL, 0l, WorkDir.c_str(), &si, &pi))
  {
  if(WaitEnd)WaitForSingleObject(pi.hProcess, INFINITE);
  }
CloseHandle(pi.hProcess);
CloseHandle(pi.hThread);
}
//---------------------------------------------------------------------------
//   ""   N "x",   "c"
String GetPrm(String a, int x, char c)
{
String r="";
int l=a.Length(), j=0;
for(int i=1; i<=l; i++)
  {
  if(a[i]==c){j++; continue;}
  if(j>x)break;
  if(j==x)r=r+a[i];
  }
return(r);
}
//---------------------------------------------------------------------------
//    
bool UFGetL(FILE *sr, char tmp[2002])
{
tmp[0]='\0';
if(feof(sr))return(false);
for(int i=0; i<2000; i++)
  {
  char c=char(fgetc(sr));
  if(feof(sr) || c=='\n')return(true);
  tmp[i]=c;
  tmp[i+1]='\0';
  }
return(true);
}
//---------------------------------------------------------------------------
//  16   16  4  
String HexToStr(WORD x)
{
String r="";
for(int i=0; i<4; i++)
  {
  char c=(x>>((3-i)*4))&0x0f;
  if(c<10)r+=char(c+0x30);
  if(c>=10)r+=char(c-10+'A');
  }
return(r);
}
//---------------------------------------------------------------------------
//  16   16  2  
String IntToHex(WORD x)
{
String r="";
for(int i=0; i<2; i++)
  {
  char c=(x>>((1-i)*4))&0x0f;
  if(c<10)r+=char(c+0x30);
  if(c>=10)r+=char(c-10+'A');
  }
return(r);
}
//---------------------------------------------------------------------------
bool tdError;
//   double
double ToDouble(String a)
{
int e;
String t;
double s;
if((e=a.Pos(","))>0)a[e]='.';
try{s=atof(a.c_str()); tdError=false;}catch(...){s=0; tdError=true;}
return(s);
}
//---------------------------------------------------------------------------
//   int
double ToINT(String a)
{
int i;
try{i=atoi(a.c_str());}catch(...){i=0;}
return(i);
}
//---------------------------------------------------------------------------
//   int
double ToINT3(String a)
{
int i;
try{i=atoi(a.c_str());}catch(...){i=3;}
if(i<2)i=2;
return(i);
}
//---------------------------------------------------------------------------
//    
String ToBin(BYTE x)
{
String r="";
for(int i=0; i<8; i++)if(x&(128>>i))r+="1"; else r+="0";
return(r);
}
//---------------------------------------------------------------------------
//    ( )
double Okr(double a)
{
return((int(a*100+0.5))/100.);
}
//---------------------------------------------------------------------------
String GT(sCH &ch)
{
if(ch.TimeStart==0 || ch.COD==0)return("");
else return(FormatDateTime("hh:nn:ss ", Now()-ch.TimeStart));
}
//---------------------------------------------------------------------------
void LoadIniN(TIniFile *p, sCH &ch)
{
String s, PWM, Fadc, Fizm, Fapr;
if(&ch==&Ch1)s="Ch1"; else s="Ch2";
for(int i=0; i<3; i++)
  {
  PWM=p->ReadString(s, "PWM"+IntToStr(i), "");
  Fadc=p->ReadString(s, "Fadc"+IntToStr(i), "");
  Fizm=p->ReadString(s, "Fizm"+IntToStr(i), "");
  Fapr=p->ReadString(s, "Fapr"+IntToStr(i), "");
  for(int j=0; j<PWMnum; j++)
	{
	ch.PWM[i][j]=ToINT(GetPrm(PWM, j, ';'));
	ch.Fadc[i][j]=ToINT(GetPrm(Fadc, j, ';'));
	ch.Fizm[i][j]=ToDouble(GetPrm(Fizm, j, ';'));
	ch.Fapr[i][j]=ToDouble(GetPrm(Fapr, j, ';'));
	}
  }
}
//---------------------------------------------------------------------------
void LoadIni(void)
{
DirBin=ExtractFilePath(ParamStr(0));
if(DirBin[DirBin.Length()]!='\\')DirBin=DirBin+"\\";
if(FileExists(DirBin+"zu.ini"))
  {
  TIniFile *p=new TIniFile(DirBin+"zu.ini");
  COM=p->ReadInteger("COMMON", "COM", 1);
  Timer=p->ReadInteger("COMMON", "Timer", 3);
  FormM->Timer2->Interval=Timer*1000;
  COMSpeed=p->ReadInteger("COMMON", "COMSpeed", 38400);
  AutoComStart=p->ReadBool("COMMON", "AutoComStart", false);
  AutoReadEEPROM=p->ReadBool("COMMON", "AutoReadEEPROM", false);
  SaveComLog=p->ReadBool("COMMON", "SaveComLog", false);
  SaveFes=p->ReadBool("COMMON", "SaveFes", false);
  PWMnum=p->ReadInteger("COMMON", "PWMnum", 8);
  PWMmin=p->ReadInteger("COMMON", "PWMmin", 450);
  PWMmax=p->ReadInteger("COMMON", "PWMmax", 6000);
  SplinePow=p->ReadInteger("COMMON", "SplinePow", 5);
  SplineType=p->ReadInteger("COMMON", "SplineType", 0);
  LastMacro1=p->ReadString("COMMON", "LastMacro1", "macro.zuml");
  LastMacro2=p->ReadString("COMMON", "LastMacro2", "macro.zuml");

  LoadIniN(p, Ch1);
  LoadIniN(p, Ch2);

  delete p;
  }
}
//---------------------------------------------------------------------------
void SaveIniN(TIniFile *p, sCH &ch)
{
String s, PWM, Fadc, Fizm, Fapr;
if(&ch==&Ch1)s="Ch1"; else s="Ch2";
for(int i=0; i<3; i++)
  {
  PWM="";
  Fadc="";
  Fizm="";
  Fapr="";
  for(int j=0; j<PWMnum; j++)
	{
	PWM+=String(ch.PWM[i][j])+";";
	Fadc+=String(ch.Fadc[i][j])+";";
	Fizm+=FormatFloat("0.000", ch.Fizm[i][j])+";";
	Fapr+=FormatFloat("0.000", ch.Fapr[i][j])+";";
	}
  p->WriteString(s, "PWM"+IntToStr(i), PWM);
  p->WriteString(s, "Fadc"+IntToStr(i), Fadc);
  p->WriteString(s, "Fizm"+IntToStr(i), Fizm);
  p->WriteString(s, "Fapr"+IntToStr(i), Fapr);
  }
}
//---------------------------------------------------------------------------
void SaveIni(void)
{
TIniFile *p=new TIniFile(DirBin+"zu.ini");
p->WriteInteger("COMMON", "COM", COM);
p->WriteInteger("COMMON", "Timer", Timer);
p->WriteInteger("COMMON", "COMSpeed", COMSpeed);
p->WriteBool("COMMON", "AutoComStart", AutoComStart);
p->WriteBool("COMMON", "AutoReadEEPROM", AutoReadEEPROM);
p->WriteBool("COMMON", "SaveComLog", SaveComLog);
p->WriteBool("COMMON", "SaveFes", SaveFes);
p->WriteInteger("COMMON", "PWMnum", PWMnum);
p->WriteInteger("COMMON", "PWMmin", PWMmin);
p->WriteInteger("COMMON", "PWMmax", PWMmax);
p->WriteInteger("COMMON", "SplinePow", SplinePow);
p->WriteInteger("COMMON", "SplineType", SplineType);
p->WriteString("COMMON", "LastMacro1", LastMacro1);
p->WriteString("COMMON", "LastMacro2", LastMacro2);
SaveIniN(p, Ch1);
SaveIniN(p, Ch2);
delete p;
}
//---------------------------------------------------------------------------
void InitCh(sCH &ch)
{
ch.A=0;
ch.Z=1;
ch.iP=0;
ch.TimeStart=0;
ch.TimeStartF=0;
ch.iMAC=ch.cMAC=0;
ch.I[0]=ch.V[0]=ch.Vmax=ch.T[0]=ch.Tc[0]=ch.E[0]=ch.Ep[0]=ch.P[0]=ch.R[0]=ch.UI[0]=ch.UV[0]=ch.UT[0]=0;
ch.cIC=ch.cID=0;
ch.Hint="";
ch.fMac=false;
ch.CodeStop=0;
ch.COD=0;
ch.fMac=0;
}
//---------------------------------------------------------------------------
//      
String GetS(int n)
{
String s="";
int LCD_W=20;
for(int i=n*LCD_W; i<(n+1)*LCD_W; i++)
  {
  BYTE c;
  c=InBuf[i+1];
  switch(c)
	{
	case 1: c='_'; break;
	case 2: c='='; break;
	case 3: c='#'; break;
	case 4: c=176; break;
	case 5: c=177; break;
	case 6: c='>'; break;
	case 7: c='A'; break;
	case 8: c=176; break;
	}
  if(c>31)s+=char(c);
  else s+=" ";
  }
return(s);
}
//---------------------------------------------------------------------------
//        
void LogAkk(FILE *tg, String Mes)
{
Mes=FormatDateTime("dd.mm.yyyy hh:nn:ss ", Now())+Mes;
fprintf(tg, "%s\n", Mes.c_str());
if(!fComOpend)
  {
  Mes=FormatDateTime("dd.mm.yyyy hh:nn:ss ", Now())+"   COM-.";
  fprintf(tg, "%s\n", Mes.c_str());
  }
}
//---------------------------------------------------------------------------
void ReShowAll(void);
//    -
void DialogOpenCOM(void)
{
if(!fComOpend)
  {
  Application->CreateForm(__classid(TFormCOM), &FormCOM);
  FormCOM->ShowModal();
  FormCOM->Free();
  if(rezFormCOM>0)
	{
	COM=rezFormCOM;
	OpenCOM(COM, COMSpeed);
	if(!fComOpend)ShowMessage("COM"+IntToStr(COM)+"  !!!");
	}
  }
ReShowAll();
}
//---------------------------------------------------------------------------
//       
// f=0 -  
// f=1 -     
// f=3 -     
//  OutBuf[2]   b7=0 - 1 ; 				b7=1 -  ;
//  OutBuf[2]   b6=0 -  ; 				b6=1 -  
//  OutBuf[2]   b5=0 -   ; 		b5=1 -   
//  OutBuf[2]   b4=0 -   ; 	b4=1 -   
//  OutBuf[2]   b3=0 -  ; 	b3=1 -  
void sb_go(sCH &ch, int f)
{
WORD xx;
if(fOnLine)return;                	//    
fOnLine=true;                     	//   

OutBuf[0]=U_GO;                   	//   / 
OutBuf[1]=0;                      	//  
OutBuf[2]=0;                      	//  , /, /, I/V, Ch/Disch
OutBuf[3]=0;                      	//  
OutBuf[4]=0;                      	// 
OutBuf[5]=0;                      	//   
OutBuf[6]=0;                      	// *10   *100   *100  
OutBuf[7]=0;                      	// *10   *100   *100  

if(f==0)
  {
  if(&ch==&Ch1)OutBuf[2]=0;       	//   
  if(&ch==&Ch2)OutBuf[2]=128;     	//   
  }
if(f==1)                          	//     
  {
  OutBuf[1]=ch.A;				  	//   
  OutBuf[3]=ch.Reg; 				//     
  OutBuf[4]=ch.Speed; 				//   
  OutBuf[5]=ch.N;  					//  
  xx=WORD(int(floor(ch.Z*10.)));
  OutBuf[6]=xx&0xff;                //   
  OutBuf[7]=(xx>>8)&3;              //   
  if(xx==0 || OutBuf[5]==0 || OutBuf[5]>20){ShowMessage("  :  !"); return;}
  if(&ch==&Ch1)OutBuf[2]=64;        //   
  if(&ch==&Ch2)OutBuf[2]=64+128;    //   
  }
if(f==3)      						//  
  {
  if(&ch==&Ch1)OutBuf[2]=64+32;     //   
  if(&ch==&Ch2)OutBuf[2]=128+64+32; //   
  if(ch.fCD)OutBuf[2]+=8;     		//  
  if(ch.fIV)						//     
	{
	OutBuf[2]+=16;
	xx=WORD(int(floor(ch.VV*100.)));//  
	}
  else                              //     
	{
	xx=WORD(int(floor(ch.II*100.)));//  
	}
  OutBuf[6]=xx&0xff;              //   Ch1.II  Ch1.VV
  OutBuf[7]=(xx>>8);              //   Ch1.II  Ch1.VV
  }
OutBuf[8]=CrcBuf8(OutBuf, 8);   //  
iOutBuf=9;                      //  6   
SendCommandToCOM();             // 

fOnLine=false;                  //    
}
//---------------------------------------------------------------------------
extern bool fAkkStart;
void LoadMacro(sCH &ch);
//   
void StartCh(sCH &ch)
{
String s;
DialogOpenCOM();
if(!fComOpend)return;				//   

if(ch.COD>0 && ch.COD!=3)return;				//    
if(FormM->RadioButton1->Checked)				//      
  {
  InitCh(ch);
  Application->CreateForm(__classid(TFormStart), &FormStart);
  FormStart->ShowModal();
  if(!fAkkStart)return;
  ch.A=FormStart->ComboBox1->ItemIndex;
  ch.Aname=FormStart->ComboBox1->Text;
  ch.Reg=FormStart->ComboBox2->ItemIndex;
  ch.RegName=FormStart->ComboBox2->Text;
  ch.Speed=FormStart->ComboBox3->ItemIndex;
  ch.SpeedName=FormStart->ComboBox3->Text;
  ch.N=ToINT(FormStart->Edit1->Text);
  ch.Z=ToDouble(FormStart->Edit2->Text);
  FormStart->Free();
  WORD a=0x4000+LenAkkEE*ch.A;                 	//     
  ch.AT=Mega[a+10];                           	//  
  WORD aa=0x4000+LenAkkEE*NumAkkEE+LenTypEE*ch.AT;//   
  ch.TimeStart=Now();
  ch.CodeStop=0;								//     "  "
  ch.FName=DirBin+"GRA\\"+FormatDateTime("ddmmyynnss", Now())+".gra"; //    
  ch.tg=fopen(ch.FName.c_str(), "w");           //    
  if(ch.tg==NULL){ShowMessage("    "+ch.FName+"  ."); return;}
  if(&ch==&Ch1)LogAkk(ch.tg, " 1    "); else LogAkk(ch.tg, " 2    ");
  LogAkk(ch.tg, ": "+ch.Aname);
  LogAkk(ch.tg, "  S: "+String(ch.N));
  LogAkk(ch.tg, " (): "+FormatFloat("0.00", ch.Z));
  s=""; for(int i=0; i<LenAkkEE; i++)s+=IntToStr(Mega[a+i])+" ";
  LogAkk(ch.tg, "  : "+s);
  s=""; for(int i=0; i<10; i++)s+=char(Mega[aa+i]);
  ch.ATname=String(" "+s).Trim();
  LogAkk(ch.tg, ": "+ch.ATname);
  s=""; for(int i=0; i<LenTypEE; i++)s+=IntToStr(Mega[aa+i])+" ";
  LogAkk(ch.tg, "  : "+s);
  LogAkk(ch.tg, ": "+ch.RegName);
  LogAkk(ch.tg, ": "+ch.SpeedName);
  LogAkk(ch.tg, ": "+String(Timer)+" .");
  LogAkk(ch.tg, "***  :");
  ch.Txt=": "+ch.Aname+"\n S: "+String(ch.N)+"\n (): "+FormatFloat("0.00", ch.Z)+"\n: "+ch.RegName+"\n: "+ch.SpeedName;
  ch.iP_last=0;                                 //     
  FormM->Timer2->Enabled=false;                 //        
  sb_go(ch, 1); ch.COD=1;                      	//      
  FormM->Timer2->Enabled=true;                  //  
  }
if(FormM->RadioButton2->Checked)			   	//      
  {
  if(ch.COD==0)                                	//  
	{
	InitCh(ch);
	ch.TimeStart=Now();
	ch.CodeStop=0;							   	//     "  "
	ch.FName=DirBin+"GRA\\"+FormatDateTime("ddmmyynnss", Now())+".gra"; //    
	ch.tg=fopen(ch.FName.c_str(), "w");        	//    
	if(ch.tg==NULL){ShowMessage("    "+ch.FName+"  ."); return;}
	if(&ch==&Ch1)LogAkk(ch.tg, " 1    "); else LogAkk(ch.tg, " 2    ");
	LogAkk(ch.tg, ": "+(ch.fCD?String(""):String("")));
	LogAkk(ch.tg, ": "+(ch.fIV?String(" "):String(" ")));
	LogAkk(ch.tg, " : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II)));
	LogAkk(ch.tg, ": "+String(Timer)+" .");
	LogAkk(ch.tg, "***  :");
	ch.Txt=": "+(ch.fCD?String(""):String(""))+"\n: "+(ch.fIV?String(" "):String(" "))+"\n : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II));
	ch.iP_last=0;                               //     
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 3); ch.COD=3;						//      
	FormM->Timer2->Enabled=true;                //  
	}
  else
	{
	LogAkk(ch.tg, ": "+(ch.fCD?String(""):String("")));
	LogAkk(ch.tg, ": "+(ch.fIV?String(" "):String(" ")));
	LogAkk(ch.tg, " : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II)));
	ch.Txt=": "+(ch.fCD?String(""):String(""))+"\n: "+(ch.fIV?String(" "):String(" "))+"\n : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II));
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 3); ch.COD=3;                     //     
	FormM->Timer2->Enabled=true;                //  
	}
  }
if(FormM->RadioButton3->Checked)				//      
  {
  if(!ch.fMac)									//    
	{                   						//  
	InitCh(ch);
	LoadMacro(ch);								//    
	if(ch.iMAC==0){ShowMessage("  !!!"); return;} //  .   
	ch.FName=DirBin+"GRA\\"+FormatDateTime("ddmmyynnss", Now())+".gra"; //    
	ch.tg=fopen(ch.FName.c_str(), "w");        	//    
	if(ch.tg==NULL){ShowMessage("    "+ch.FName+"  ."); return;}
	if(&ch==&Ch1)LogAkk(ch.tg, " 1    "); else LogAkk(ch.tg, " 2    ");
	LogAkk(ch.tg, "***  :");
	ch.iP_last=0;                               //     
	ch.TimeStart=Now();
	ch.TimeStartF=Now(); 						//     
	ch.fMac=true;
	ch.Txt="";
	FormM->Timer2->Enabled=true;
	}
  else
	{
	LogAkk(ch.tg, ": "+(ch.fCD?String(""):String("")));
	LogAkk(ch.tg, ": "+(ch.fIV?String(" "):String(" ")));
	LogAkk(ch.tg, " : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II)));
	ch.Txt=": "+(ch.fCD?String(""):String(""))+"\n: "+(ch.fIV?String(" "):String(" "))+"\n : "+(ch.fIV?FormatFloat("0.00", ch.VV):FormatFloat("0.00", ch.II));
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 3); ch.COD=3;                     //     
	FormM->Timer2->Enabled=true;                //  
	}
  }
ReShowAll();
}
//---------------------------------------------------------------------------
//   
void StopCh(sCH &ch)
{
if(FormM->RadioButton1->Checked)				//      
  {
  if(ch.COD==2)                				   	//    
	{
	LogAkk(ch.tg, "###  ");
	if(&ch==&Ch1)LogAkk(ch.tg, " 1 "); else LogAkk(ch.tg, " 2 ");
	if(ch.iP>0)LogAkk(ch.tg, ": "+FormatFloat("0.00", ch.E[ch.iP-1])+"  ("+FormatFloat("0.0", ch.Ep[ch.iP-1])+"%)");
	LogAkk(ch.tg, ": "+IntToStr(ch.CodeStop));
	LogAkk(ch.tg, ": "+Prich[ch.CodeStop]);
	double x=Now()-ch.TimeStart;
	LogAkk(ch.tg, ": "+String(floor(x*24*60))+" .");
	fclose(ch.tg);                              //  
	ch.COD=0;
	}
  else                                         	//    
	{                                          	//     
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 0);                               //      1 
	FormM->Timer2->Enabled=true;                //  
	}
  }
if(FormM->RadioButton2->Checked)				//      
  {
  if(ch.COD==4)                 				//    
	{
	LogAkk(ch.tg, "###  ");
	if(&ch==&Ch1)LogAkk(ch.tg, " 1 "); else LogAkk(ch.tg, " 2 ");
	LogAkk(ch.tg, ": "+IntToStr(ch.CodeStop));
	LogAkk(ch.tg, ": "+Prich[ch.CodeStop]);
	double x=Now()-ch.TimeStart;
	LogAkk(ch.tg, ": "+String(floor(x*24*60))+" .");
	fclose(ch.tg);                              //  
	ch.COD=0;
	}
  if(ch.COD==3)                 				//    
	{                                          	//     
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 0);                               //    1 
	FormM->Timer2->Enabled=true;                //  
	}
  }
if(FormM->RadioButton3->Checked)				//      
  {
  if(ch.COD==4)                 				//    
	{                   						//  
	LogAkk(ch.tg, "###  ");
	if(&ch==&Ch1)LogAkk(ch.tg, " 1 "); else LogAkk(ch.tg, " 2 ");
	ch.fMac=false;
	LogAkk(ch.tg, ": "+IntToStr(ch.CodeStop));
	LogAkk(ch.tg, ": "+Prich[ch.CodeStop]);
	double x=Now()-ch.TimeStart;
	LogAkk(ch.tg, ": "+String(floor(x*24*60))+" .");
	fclose(ch.tg);                              //  
	ch.COD=0;
	}
  if(ch.COD==3)                 				//    
	{                                          	//     
	FormM->Timer2->Enabled=false;               //        
	sb_go(ch, 0);                               //    1 
	FormM->Timer2->Enabled=true;                //  
	}
  }
if(Ch1.COD==0 && Ch2.COD==0)FormM->Timer2->Enabled=false; //    ,    
ReShowAll();
}
//---------------------------------------------------------------------------
//  double  String
String FFF(double a)
{
String rez="   ";
rez+=FormatFloat("0.00", a);
return(rez.SubString(rez.Length()-6, 7));
}
//---------------------------------------------------------------------------
//   
// k -   
// M[] -   
float SPL(long k, double M[])
{
if(SplinePow<0 || k<0)return(0);    //     
if(SplinePow==0 || k==0)return(M[k]);//      

long i0;
float sum=0;                    	//   
int n;                           	//    (n+1  )
if(k<=SplinePow-1){i0=0; n=k;}      //    ,      
else {i0=k-SplinePow; n=SplinePow;} //    ,   


for(long i=i0; i<=k; i++)sum+=M[i];

return(sum/(n+1));
}
//---------------------------------------------------------------------------
//   StatusBar
void StatusBarShow(sCH &ch)
{
TRect r, r2;
TCanvas *t=FormM->StatusBar1->Canvas;

//     
String T[3]={"", "", ""};
if(fComOpend)                  		//  COM- 
  FormM->StatusBar1->Panels->Items[0]->Text="COM"+IntToStr(COM);
else                           		//  COM- 
  {
  strIN=strOUT=strERR=0;
  FormM->StatusBar1->Panels->Items[0]->Text="COM off";
  }
FormM->StatusBar1->Panels->Items[1]->Text="I/O/E="+String(strIN)+"/"+String(strOUT)+"/"+String(strERR);
FormM->StatusBar1->Panels->Items[2]->Text="1:"+T[Ch1.Type]+" "+GT(Ch1)+(STATE&128?"W":".")+(STATE&64?"Z":".")+(STATE&32?"L":".")+(STATE&16?"V":"I");
FormM->StatusBar1->Panels->Items[3]->Text="2:"+T[Ch2.Type]+" "+GT(Ch2)+(STATE&8?"W":".")+(STATE&4?"Z":".")+(STATE&2?"L":".")+(STATE&1?"V":"I");
FormM->StatusBar1->Panels->Items[4]->Text="F/E/R="+HexToStr(CS_FLASH)+"/"+HexToStr(CS_EEPROM)+"/"+HexToStr(CS_RAM);
//       
t->Font->Size=FormM->StatusBar1->Font->Size;
for(int i=0; i<5; i++)FormM->StatusBar1->Panels->Items[i]->Width=t->TextWidth(FormM->StatusBar1->Panels->Items[i]->Text)+10;

String txt=FormatFloat("0.0", StBarVal*100.)+"%";
StBarVal=StBarVal<0?0:StBarVal;
StBarVal=StBarVal>1?1:StBarVal;
		//   ,    
if(StBarVal==0 && ch.COD==0){t->Brush->Color=clBtnFace; t->FillRect(StBarRect);}
else	//   ,     
  {
  r=StBarRect;
  r.Right=(r.Right-r.Left)*StBarVal+r.Left;
  t->Brush->Color=clSkyBlue;
  t->FillRect(r);

  r2=StBarRect;
  r2.Left=r.Right;
  t->Brush->Color=clBtnFace;
  t->FillRect(r2);

  t->Font->Size=FormM->StatusBar1->Font->Size;
  t->Font->Color=FormM->StatusBar1->Font->Color;
  t->Brush->Style=bsClear;
  t->TextOut((r.Left+StBarRect.Right-t->TextWidth(txt))/2, 4, txt);
  }
Application->ProcessMessages();
}
//---------------------------------------------------------------------------
//  
void CHA(TChart *c, int l, int t, int w, int h)
{
c->Left=l;
c->Top=t;
c->Width=w;
c->Height=h;
}
//---------------------------------------------------------------------------
void ReText(TRichEdit *r);
//   
void ReShowAll(void)
{
Application->HintHidePause=3000;
if(fClose)return;
sCH *ch=fCH?&Ch2:&Ch1;
FormM->RadioButton1->Checked=(*ch).Type==0;
FormM->RadioButton2->Checked=(*ch).Type==1;
FormM->RadioButton3->Checked=(*ch).Type==2;

if(fComOpend)                  		//  COM- 
  {
  }
else                           		//  COM- 
  {
  StBarVal=0;
  strIN=strOUT=strERR=0;
  S1=""; S2=""; S3=""; S4="";
  }

if((*ch).COD>0)                     //   ,     
  {
  FormM->Panel2->Visible=true;
  FormM->Panel2->Align=alClient;
  FormM->RichEdit1->Visible=false;
  FormM->RichEdit1->Align=alNone;

  if((*ch).iP>0 && FormM->RadioButton1->Checked)StBarVal=(*ch).Ep[(*ch).iP-1]/100.; //     
  if(FormM->RadioButton1->Checked)FormM->Button1->Enabled=false;//   
  if(FormM->RadioButton2->Checked)FormM->Button1->Enabled=true; //   
  if(FormM->RadioButton3->Checked)FormM->Button1->Enabled=false;//   
  FormM->Button2->Enabled=true;
  FormM->RadioButton1->Enabled=false;
  FormM->RadioButton2->Enabled=false;
  FormM->RadioButton3->Enabled=false;
  }
else
  {
  if(FormM->RadioButton3->Checked)
	{
	FormM->RichEdit1->Visible=true;
	FormM->RichEdit1->Align=alClient;
	FormM->Panel2->Visible=false;
	FormM->Panel2->Align=alNone;

	}
  else
	{
	FormM->Panel2->Visible=true;
	FormM->Panel2->Align=alClient;
	FormM->RichEdit1->Visible=false;
    FormM->RichEdit1->Align=alNone;
	}
  FormM->Button1->Enabled=true;
  FormM->Button2->Enabled=false;
  FormM->RadioButton1->Enabled=true;
  FormM->RadioButton2->Enabled=true;
  FormM->RadioButton3->Enabled=true;
  }

int d=3;
int h=FormM->Panel2->Height-6;
int w=FormM->Panel2->Width-6;
int wb;

if(FormM->RadioButton1->Checked)  	//   
  {
  wb=0;
  FormM->Image1->Visible=false;
  FormM->Image2->Visible=false;
  FormM->GroupBox2->Visible=false;
  FormM->GroupBox3->Visible=false;
  FormM->Button7->Visible=false;
  FormM->Button8->Visible=false;

  FormM->Panel5->Left=5;
  FormM->Panel5->Top=FormM->Panel4->Height+FormM->TabSet1->Height;
  FormM->Panel5->Height=FormM->Panel1->Height-FormM->Panel3->Height-FormM->Panel5->Top-10;
  FormM->Panel5->Width=FormM->Panel1->Width-15;
  }
if(FormM->RadioButton2->Checked)  	//   
  {
  FormM->RadioButton4->Enabled=true;
  FormM->RadioButton5->Enabled=true;
  FormM->RadioButton6->Enabled=true;
  FormM->RadioButton7->Enabled=true;

  FormM->RadioButton4->Checked=!(*ch).fIV;
  FormM->RadioButton5->Checked=(*ch).fIV;
  wb=Isize+5;
  double i=0, v=0;
  if((*ch).iP>0){i=(*ch).I[(*ch).iP-1]; v=(*ch).V[(*ch).iP-1];}
  if(FormM->RadioButton4->Checked)
	{
	VA(1, i, (*ch).II, 5, "A");
	VA(2, v, -1, 30, "V");
	}
  else
	{
	VA(1, i, -1, 5, "A");
	VA(2, v, (*ch).VV, 30, "V");
	}
  FormM->Image1->Visible=true;
  FormM->Image2->Visible=true;
  FormM->GroupBox2->Visible=true;
  FormM->GroupBox3->Visible=true;
  FormM->Button7->Visible=false;
  FormM->Button8->Visible=false;

  FormM->Panel5->Left=5;
  FormM->Panel5->Top=FormM->Panel4->Height+FormM->TabSet1->Height;
  FormM->Panel5->Height=FormM->Panel1->Height-FormM->Panel3->Height-FormM->Panel5->Top-10;
  FormM->Panel5->Width=FormM->Panel1->Width-15;
  }
if(FormM->RadioButton3->Checked)  	//   
  {
  FormM->RadioButton4->Enabled=false;
  FormM->RadioButton5->Enabled=false;
  FormM->RadioButton6->Enabled=false;
  FormM->RadioButton7->Enabled=false;

  FormM->RadioButton4->Checked=!(*ch).fIV;
  FormM->RadioButton5->Checked=(*ch).fIV;
  wb=Isize+5;
  double i=0, v=0;
  if((*ch).iP>0){i=(*ch).I[(*ch).iP-1]; v=(*ch).V[(*ch).iP-1];}
  if(FormM->RadioButton4->Checked){VA(1, i, (*ch).II, 5, "A"); VA(2, v, -1, 30, "V");}
  else{VA(1, i, -1, 5, "A"); VA(2, v, (*ch).VV, 30, "V");}
  FormM->Image1->Visible=true;
  FormM->Image2->Visible=true;
  FormM->GroupBox2->Visible=true;
  FormM->GroupBox3->Visible=true;
  FormM->Button7->Visible=true;
  FormM->Button8->Visible=true;

  FormM->Panel5->Left=5;
  FormM->Panel5->Top=FormM->Button7->Top+FormM->Button7->Height+5;
  FormM->Panel5->Height=FormM->Panel1->Height-FormM->Panel3->Height-FormM->Panel5->Top-10;
  FormM->Panel5->Width=FormM->Panel1->Width-15;
  FormM->RichEdit1->Font->Size=9;
  FormM->RichEdit1->Lines->Text=(*ch).TextMacro;
  FormM->RichEdit1->CaretPos.x=(*ch).CaretPosX;
  FormM->RichEdit1->CaretPos.y=(*ch).CaretPosY;
  FormM->RichEdit1->ReadOnly=false;
  }
int lc=wb+d, wc=((w-wb-d-d)/2)-d, hc=(h/5)-d;

if((*ch).iP>0)
  {
  if((*ch).CodeStop>0)FormM->Label5->Caption=Prich[(*ch).CodeStop];else FormM->Label5->Caption="";
  FormM->Label6->Caption="Index ="+FFF((*ch).iP-1);
  FormM->Label7->Caption="I()  ="+FFF((*ch).I[(*ch).iP-1]);
  FormM->Label8->Caption="V()  ="+FFF((*ch).V[(*ch).iP-1]);
  FormM->Label9->Caption="T() ="+FFF((*ch).T[(*ch).iP-1]);
  FormM->Label10->Caption="Tc()="+FFF((*ch).Tc[(*ch).iP-1]);
  FormM->Label11->Caption="E() ="+FFF((*ch).E[(*ch).iP-1]);
  FormM->Label12->Caption="E%    ="+FFF((*ch).Ep[(*ch).iP-1]);
  FormM->Label13->Caption="P() ="+FFF((*ch).P[(*ch).iP-1]);
  FormM->Label14->Caption="R() ="+FFF((*ch).R[(*ch).iP-1]);
  FormM->Label15->Caption="dI/dt ="+FFF((*ch).UI[(*ch).iP-1]);
  FormM->Label16->Caption="dV/dt ="+FFF((*ch).UV[(*ch).iP-1]);
  FormM->Label17->Caption="dT/dt ="+FFF((*ch).UT[(*ch).iP-1]);

  FormM->Label18->Caption=GetPrm((*ch).Txt, 0, '\n');
  FormM->Label19->Caption=GetPrm((*ch).Txt, 1, '\n');
  FormM->Label20->Caption=GetPrm((*ch).Txt, 2, '\n');
  FormM->Label21->Caption=GetPrm((*ch).Txt, 3, '\n');
  FormM->Label22->Caption=GetPrm((*ch).Txt, 4, '\n');
  if(FormM->RadioButton3->Checked)
	{
	FormM->Label23->Caption=GetPrm((*ch).Hint, 0, '\n');
	FormM->Label24->Caption=GetPrm((*ch).Hint, 1, '\n');
	FormM->Label25->Caption=GetPrm((*ch).Hint, 2, '\n');
	FormM->Label26->Caption=GetPrm((*ch).Hint, 3, '\n');
	FormM->Label27->Caption=GetPrm((*ch).Hint, 4, '\n');
	FormM->Label28->Caption=GetPrm((*ch).Hint, 5, '\n');
	FormM->Label29->Caption=GetPrm((*ch).Hint, 6, '\n');
	}
  else
	{
	FormM->Label23->Caption="";
	FormM->Label24->Caption="";
	FormM->Label25->Caption="";
	FormM->Label26->Caption="";
	FormM->Label27->Caption="";
	FormM->Label28->Caption="";
	FormM->Label29->Caption="";
	}
  }

if((*ch).tCt==NULL)
  {
  FormM->Chart1->Visible=true;
  FormM->Chart2->Visible=true;
  FormM->Chart3->Visible=true;
  FormM->Chart4->Visible=true;
  FormM->Chart5->Visible=true;
  FormM->Chart6->Visible=true;
  FormM->Chart7->Visible=true;
  FormM->Chart8->Visible=true;
  FormM->Chart9->Visible=true;
  FormM->Chart10->Visible=true;
  CHA(FormM->Chart1, lc+d, d, wc, hc);
  CHA(FormM->Chart8, lc+d+wc+d, d, wc, hc);
  CHA(FormM->Chart2, lc+d, d+hc+d, wc, hc);
  CHA(FormM->Chart9, lc+d+wc+d, d+hc+d, wc, hc);
  CHA(FormM->Chart3, lc+d, d+hc+d+hc+d, wc, hc);
  CHA(FormM->Chart10, lc+d+wc+d, d+hc+d+hc+d, wc, hc);
  CHA(FormM->Chart4, lc+d, d+hc+d+hc+d+hc+d, wc, hc);
  CHA(FormM->Chart6, lc+d+wc+d, d+hc+d+hc+d+hc+d, wc, hc);
  CHA(FormM->Chart5, lc+d, d+hc+d+hc+d+hc+d+hc+d, wc, hc);
  CHA(FormM->Chart7, lc+d+wc+d, d+hc+d+hc+d+hc+d+hc+d, wc, hc);
  }
else
  {
  FormM->Chart1->Visible=false;
  FormM->Chart2->Visible=false;
  FormM->Chart3->Visible=false;
  FormM->Chart4->Visible=false;
  FormM->Chart5->Visible=false;
  FormM->Chart6->Visible=false;
  FormM->Chart7->Visible=false;
  FormM->Chart8->Visible=false;
  FormM->Chart9->Visible=false;
  FormM->Chart10->Visible=false;
  (*ch).tCt->Visible=true;
  CHA((*ch).tCt, lc+d, d, w-wb-d, h-d);
  }


//  
//  
if((*ch).iP_last==0)			//   
  {
  FormM->Chart1->Series[0]->Clear();
  FormM->Chart2->Series[0]->Clear();
  FormM->Chart3->Series[0]->Clear();
  FormM->Chart3->Series[1]->Clear();
  FormM->Chart4->Series[0]->Clear();
  FormM->Chart5->Series[0]->Clear();
  FormM->Chart6->Series[0]->Clear();
  FormM->Chart7->Series[0]->Clear();
  FormM->Chart8->Series[0]->Clear();
  FormM->Chart9->Series[0]->Clear();
  FormM->Chart10->Series[0]->Clear();
  }
if((*ch).iP>(*ch).iP_last)
  {
  for(long i=(*ch).iP_last; i<(*ch).iP; i++)
	{
	double I=(*ch).I[i],
		  V=(*ch).V[i],
		  T=(*ch).T[i],
		  Tc=(*ch).Tc[i],
		  E=(*ch).E[i],
		  Ep=(*ch).Ep[i],
		  P=(*ch).P[i],
		  R=(*ch).R[i],
		  UI=(*ch).UI[i],
		  UV=(*ch).UV[i],
		  UT=(*ch).UT[i];
	if(SplineType==1)
	  {
	  I =SPL(i, (*ch).I);
	  V =SPL(i, (*ch).V);
	  T =SPL(i, (*ch).T);
	  Tc=SPL(i, (*ch).Tc);
	  E =SPL(i, (*ch).E);
	  Ep=SPL(i, (*ch).Ep);
	  P =SPL(i, (*ch).P);
	  R =SPL(i, (*ch).R);
	  UI=SPL(i, (*ch).UI);
	  UV=SPL(i, (*ch).UV);
	  UT=SPL(i, (*ch).UT);
	  }

	FormM->Chart1->Series[0]->AddY(I, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart2->Series[0]->AddY(V, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart3->Series[0]->AddY(T, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart3->Series[1]->AddY(Tc, Okr((*ch).Time[i]), clTeeColor);//      
	FormM->Chart4->Series[0]->AddY(E, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart5->Series[0]->AddY(Ep, Okr((*ch).Time[i]), clTeeColor);//      
	FormM->Chart6->Series[0]->AddY(P, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart7->Series[0]->AddY(R, Okr((*ch).Time[i]), clTeeColor); //      
	FormM->Chart8->Series[0]->AddY(UI, Okr((*ch).Time[i]), clTeeColor);//      
	FormM->Chart9->Series[0]->AddY(UV, Okr((*ch).Time[i]), clTeeColor);//      
	FormM->Chart10->Series[0]->AddY(UT, Okr((*ch).Time[i]), clTeeColor); //      
	}
  (*ch).iP_last=(*ch).iP;
  }
StatusBarShow(*ch);
}
//---------------------------------------------------------------------------
//       
double tSB;                   //    U_GiveMeADC
void SB(BYTE x)
{
double I, V, T, Tc, E, Ep, P, R, UI, UV, UT;

DialogOpenCOM();
if(!fComOpend)return;         //   
if(fOnLine)return;            //    ,      
fOnLine=true;                 //     
OutBuf[0]=x;                  //      
iOutBuf=1;                    //   
if(!SendCommandToCOM())return;
if(InBuf[0]==U_OK || InBuf[0]==U_CANCEL || InBuf[0]==U_UP || InBuf[0]==U_DOWN || InBuf[0]==U_GiveMeScr)
  {  //    83/35 (, 80/32 ,  )
  fc=InBuf[81];               // 
  fFlash=(fc>128 && fc!=255); // 
  switch(InBuf[0])
	{
	case U_OK:
	case U_CANCEL:
	case U_UP:
	case U_DOWN:
	case U_GiveMeScr:
	  S1=GetS(0); FormM->Label1->Caption=S1;
	  S2=GetS(1); FormM->Label2->Caption=S2;
	  S3=GetS(2); FormM->Label3->Caption=S3;
	  S4=GetS(3); FormM->Label4->Caption=S4;
	  break;
	}
  }
if(InBuf[0]==U_GiveMeADC)            //  
  {  //   25  (, 23 ,  )
  //     
  STATE=InBuf[23];
//                     1/0
//                     b7 1 /
//                     b6 1 /
//                     b5 1  /
//                     b4 1  V/ I
//                     b3 2 /
//                     b2 2 /
//                     b1 2  /
//                     b0 2  V/ I


  double dt=(double(Now())-tSB)*24*60*60;	// ,    
//  1   (iP=)   (iP=0)
  Ch1.I[Ch1.iP]=(double(InBuf[2])*256+InBuf[1])/100.;
  Ch1.V[Ch1.iP]=(double(InBuf[4])*256+InBuf[3])/100.;
  if(Ch1.V[Ch1.iP]>Ch1.Vmax)Ch1.Vmax=Ch1.V[Ch1.iP];
  Ch1.P[Ch1.iP]=Ch1.I[Ch1.iP]*Ch1.V[Ch1.iP];
  if(Ch1.I[Ch1.iP]>0)Ch1.R[Ch1.iP]=Ch1.V[Ch1.iP]/Ch1.I[Ch1.iP];
  Ch1.T[Ch1.iP]=(double(InBuf[6])*256+InBuf[5])/100.; if(Ch1.T[Ch1.iP]>200)Ch1.T[Ch1.iP]=0;
  Ch1.Tc[Ch1.iP]=(double(InBuf[16])*256+InBuf[15])/100.; if(Ch1.Tc[Ch1.iP]>200)Ch1.Tc[Ch1.iP]=0;
  Ch1.E[Ch1.iP]=(double(InBuf[18])*256+InBuf[17])/100.;
  if(Ch1.E[Ch1.iP]>103)Ch1.E[Ch1.iP]-=655.36;
  Ch1.Ep[Ch1.iP]=Ch1.E[Ch1.iP]*100./Ch1.Z;
  Ch1.Time[Ch1.iP]=(double(Now())-Ch1.TimeStart)*24*60;   //      
  Ch1.UI[Ch1.iP]=Ch1.UV[Ch1.iP]=Ch1.UT[Ch1.iP]=0;


  if(STATE&128)                             //  1  
	{
	if(dt>0.01 && Ch1.iP>0) //   
	  {
	  Ch1.UI[Ch1.iP]=(Ch1.I[Ch1.iP]-Ch1.I[Ch1.iP-1])/dt;
	  Ch1.UV[Ch1.iP]=(Ch1.V[Ch1.iP]-Ch1.V[Ch1.iP-1])/dt;
	  Ch1.UT[Ch1.iP]=(Ch1.T[Ch1.iP]-Ch1.T[Ch1.iP-1])/dt;
	  }
	if(Ch1.tg!=NULL)fprintf(Ch1.tg, "%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f;%8.2f\n",
							Okr(Ch1.Time[Ch1.iP]), Ch1.I[Ch1.iP], Ch1.V[Ch1.iP], Ch1.T[Ch1.iP], Ch1.Tc[Ch1.iP],
							Ch1.E[Ch1.iP], Ch1.Ep[Ch1.iP], Ch1.P[Ch1.iP], Ch1.R[Ch1.iP],
							Ch1.UI[Ch1.iP], Ch1.UV[Ch1.iP], Ch1.UT[Ch1.iP]);
	if(SplineType==2)
	  {
	  Ch1.I[Ch1.iP] =SPL(Ch1.iP, Ch1.I);
	  Ch1.V[Ch1.iP] =SPL(Ch1.iP, Ch1.V);
	  Ch1.T[Ch1.iP] =SPL(Ch1.iP, Ch1.T);
	  Ch1.Tc[Ch1.iP]=SPL(Ch1.iP, Ch1.Tc);
	  Ch1.E[Ch1.iP] =SPL(Ch1.iP, Ch1.E);
	  Ch1.Ep[Ch1.iP]=SPL(Ch1.iP, Ch1.Ep);
	  Ch1.P[Ch1.iP] =SPL(Ch1.iP, Ch1.P);
	  Ch1.R[Ch1.iP] =SPL(Ch1.iP, Ch1.R);
	  Ch1.UI[Ch1.iP]=SPL(Ch1.iP, Ch1.UI);
	  Ch1.UV[Ch1.iP]=SPL(Ch1.iP, Ch1.UV);
	  Ch1.UT[Ch1.iP]=SPL(Ch1.iP, Ch1.UT);
	  }
	Ch1.iP++;
	}
//  2   (iP=)   (iP=0)
  Ch2.I[Ch2.iP]=(double(InBuf[8])*256+InBuf[7])/100.;
  Ch2.V[Ch2.iP]=(double(InBuf[10])*256+InBuf[9])/100.;
  if(Ch2.V[Ch2.iP]>Ch2.Vmax)Ch2.Vmax=Ch2.V[Ch2.iP];
  Ch2.P[Ch2.iP]=Ch2.I[Ch2.iP]*Ch2.V[Ch2.iP];
  if(Ch2.I[Ch2.iP]>0)Ch2.R[Ch2.iP]=Ch2.V[Ch2.iP]/Ch2.I[Ch2.iP];
  Ch2.T[Ch2.iP]=(double(InBuf[12])*256+InBuf[11])/100.; if(Ch2.T[Ch2.iP]>200)Ch2.T[Ch2.iP]=0;
  Ch2.Tc[Ch2.iP]=(double(InBuf[16])*256+InBuf[15])/100.; if(Ch2.Tc[Ch2.iP]>200)Ch2.Tc[Ch2.iP]=0;
  Ch2.E[Ch2.iP]=(double(InBuf[20])*256+InBuf[19])/100.;
  Ch2.Ep[Ch2.iP]=Ch2.E[Ch2.iP]*100./Ch2.Z;
  if(Ch2.E[Ch2.iP]>103)Ch2.E[Ch2.iP]-=655.36;
  Ch2.Time[Ch2.iP]=(double(Now())-Ch2.TimeStart)*24*60;   //      
  Ch2.UI[Ch2.iP]=Ch2.UV[Ch2.iP]=Ch2.UT[Ch2.iP]=0;

  if(STATE&8)                               //  2  
	{
	if(dt>0.01 && Ch2.iP>1) //   
	  {
	  Ch2.UI[Ch2.iP]=(Ch2.I[Ch2.iP]-Ch2.I[Ch2.iP-1])/dt;
	  Ch2.UV[Ch2.iP]=(Ch2.V[Ch2.iP]-Ch2.V[Ch2.iP-1])/dt;
	  Ch2.UT[Ch2.iP]=(Ch2.T[Ch2.iP]-Ch2.T[Ch2.iP-1])/dt;
	  }
	if(Ch2.tg!=NULL)fprintf(Ch2.tg, "%5.2f;%5.2f;%5.2f;%5.2f;%5.2f;%8.2f;%8.2f;%8.2;%8.2f;%8.2f;%8.2f\n",
							Okr(Ch2.Time[Ch2.iP]), Ch2.I[Ch2.iP], Ch2.V[Ch2.iP], Ch2.T[Ch2.iP], Ch2.Tc[Ch2.iP],
							Ch2.E[Ch2.iP], Ch2.P[Ch2.iP], Ch2.R[Ch2.iP],
							Ch2.UI[Ch2.iP], Ch2.UV[Ch2.iP], Ch2.UT[Ch2.iP]);
	if(SplineType==2)
	  {
	  Ch2.I[Ch2.iP] =SPL(Ch2.iP, Ch2.I);
	  Ch2.V[Ch2.iP] =SPL(Ch2.iP, Ch2.V);
	  Ch2.T[Ch2.iP] =SPL(Ch2.iP, Ch2.T);
	  Ch2.Tc[Ch2.iP]=SPL(Ch2.iP, Ch2.Tc);
	  Ch2.E[Ch2.iP] =SPL(Ch2.iP, Ch2.E);
	  Ch2.Ep[Ch2.iP]=SPL(Ch2.iP, Ch2.Ep);
	  Ch2.P[Ch2.iP] =SPL(Ch2.iP, Ch2.P);
	  Ch2.R[Ch2.iP] =SPL(Ch2.iP, Ch2.R);
	  Ch2.UI[Ch2.iP]=SPL(Ch2.iP, Ch2.UI);
	  Ch2.UV[Ch2.iP]=SPL(Ch2.iP, Ch2.UV);
	  Ch2.UT[Ch2.iP]=SPL(Ch2.iP, Ch2.UT);
	  }
	Ch2.iP++;
	}

  V12=(double(InBuf[14])*256+InBuf[13])/100.;
  Ch1.CodeStop=InBuf[21]; if(Ch1.CodeStop>17)Ch1.CodeStop=18; //    1 
  Ch2.CodeStop=InBuf[22]; if(Ch2.CodeStop>17)Ch2.CodeStop=18; //    2 
  if((!(STATE&128))&&(Ch1.COD!=0))  //  1 ,   
	{
	if(Ch1.COD==1){Ch1.COD=2; StopCh(Ch1);}
	if(Ch1.COD==3){Ch1.COD=4; StopCh(Ch1);}
	}
  if((!(STATE&  8))&&(Ch2.COD!=0))  //  2 ,   
	{
	if(Ch2.COD==1){Ch2.COD=2; StopCh(Ch2);}
	if(Ch2.COD==3){Ch2.COD=4; StopCh(Ch2);}
	}
  tSB=Now();
  }
ReShowAll();

fOnLine=false;                    //     
}
//---------------------------------------------------------------------------
//     (FLASH EEPROM RAM)
bool ReadMemoryZU(WORD first, WORD length, WORD step)
{
DialogOpenCOM();
if(!fComOpend)return(false);				//   
if(FormM->Timer2->Enabled)return(false);	//      
for(WORD i=first; i<first+length; i+=step)	//     step 
  {
  if(length!=0)StBarVal=double(i-first)/length; 	//    
  OutBuf[0]=U_ReadMemory;               	//   
  OutBuf[1]=BYTE(i);                    	//   -   
  OutBuf[2]=BYTE(i>>8);                 	//   -   
  OutBuf[3]=step;                       	//   
  OutBuf[4]=CrcBuf8(OutBuf, 4);         	//     
  iOutBuf=5;                            	//    
  SendCommandToCOM();                   	//         
  for(BYTE j=0; j<step; j++)Mega[i+j]=InBuf[j+4]; //      
  FormM->StatusBar1->Repaint();
  Application->ProcessMessages();         	//       
  }
StBarVal=0;          						//  
FormM->StatusBar1->Repaint();
CS_FLASH=CrcBuf16(Mega, 0, 0x4000);			//     FLASH
CS_EEPROM=CrcBuf16(Mega, 0x4000, 0x400);	//     EEPROM
CS_RAM=CrcBuf16(Mega, 0x4400, 0x800);		//     SRAM
return(true);
}
//---------------------------------------------------------------------------
//     ( EEPROM)
bool SaveMemoryZU(WORD first, WORD length, WORD step)
{
DialogOpenCOM();
if(!fComOpend)return(false);				//   
if(FormM->Timer2->Enabled)return(false); 	//      
for(WORD i=first; i<first+length; i+=step)	//     step 
  {
  if(length!=0)StBarVal=double(i-first)/length; 	//    
  OutBuf[0]=U_WriteMemory;              	//   
  OutBuf[1]=BYTE(i);                    	//   -   
  OutBuf[2]=BYTE(i>>8);                 	//   -   
  OutBuf[3]=step;                       	//   
  for(int j=0; j<step; j++)OutBuf[4+j]=Mega[i+j]; //       
  OutBuf[4+step]=CrcBuf8(OutBuf, step+4);   //    
  iOutBuf=5+step;                       	//    
  SendCommandToCOM();                   	//         
  FormM->StatusBar1->Repaint();
  Application->ProcessMessages();         	//       
  }
StBarVal=0;          						//  
FormM->StatusBar1->Repaint();
return(true);
}
//---------------------------------------------------------------------------
//    (    Mega[])  
void MegaToFile(String name, WORD adr, WORD len)
{
if(FileExists(name))
  {
  int i=MessageBox(Application->Handle, String("  "+name+" ?").c_str(), "!!!", MB_YESNO);
  if(i!=ID_YES)return;                  	//     
  }
int iFileHandle;                        	//   
if(FileExists(name))DeleteFile(name);   	//      
iFileHandle=FileCreate(name);      			//         
if(iFileHandle>0)                       	//   
  {
  FileWrite(iFileHandle, &Mega[adr], len);	//     
  FileClose(iFileHandle);               	//  
  }
else ShowMessage("   "+name); //       
}
//---------------------------------------------------------------------------
//    (    Mega[])  
void FileToMega(String name, WORD adr, WORD len)
{
int iFileHandle;                         	//   
if(!FileExists(name))ShowMessage("   "+name); //      , 
iFileHandle=FileOpen(name, fmOpenRead);  	//  
if(iFileHandle>0)                        	//   
  {
  FileRead(iFileHandle, &Mega[adr], len);	//    
  FileClose(iFileHandle);                	//  
  }
else ShowMessage("   "+name); //    , 
CS_FLASH=CrcBuf16(Mega, 0, 0x4000);		//     FLASH
CS_EEPROM=CrcBuf16(Mega, 0x4000, 0x400);//     EEPROM
CS_RAM=CrcBuf16(Mega, 0x4400, 0x800);	//     SRAM
}
//---------------------------------------------------------------------------
//    
String LoadVarFromZU(BYTE cod)
{
DialogOpenCOM();
if(!fComOpend)return("");	  				  //   
union {BYTE i[4]; WORD w; long l; float f;}v;
OutBuf[0]=U_VAR;                              //   
OutBuf[1]=cod;                                //   -  
OutBuf[2]=CrcBuf8(OutBuf, 2);                 //     
iOutBuf=3;                                    //    
SendCommandToCOM();                           //         
v.i[0]=InBuf[2];
v.i[1]=InBuf[3];
v.i[2]=InBuf[4];
v.i[3]=InBuf[5];
switch(InBuf[1])
  {
  case 0: return(String(InBuf[2]));
  case 1: return(String(v.w));
  case 2: return(String(v.l));
  case 3: return(String(v.f));
  case 255: return("true");
  case 254: return("false");
  }
return("");
}
//---------------------------------------------------------------------------
//      
void OpenFileToGra(sCH &ch)
{
ch.iP=0;
ch.iP_last=0;
char tmp[2002];
String T;
FormM->OpenDialog1->DefaultExt="*.gra";
FormM->OpenDialog1->Filter=" |*.gra| |*.*";
FormM->OpenDialog1->InitialDir=DirBin+"GRA\\";  				//   
if(FormM->OpenDialog1->Execute())                             	//    
  {
  FILE *sr;                                            			//   
  sr=fopen(String(FormM->OpenDialog1->FileName).c_str(), "r"); 	//  
  if(sr!=NULL)                                         			//  
	{
	while(UFGetL(sr, tmp))
	  {
	  T=tmp;
	  if(T.Pos(";")!=9)continue;
	  ch.Time[ch.iP]=ToDouble(GetPrm(T, 0, ';').c_str());	// t
	  ch.I[ch.iP]=ToDouble(GetPrm(T, 1, ';').c_str());    	// I
	  ch.V[ch.iP]=ToDouble(GetPrm(T, 2, ';').c_str());    	// V
	  ch.T[ch.iP]=ToDouble(GetPrm(T, 3, ';').c_str());    	// T
	  ch.Tc[ch.iP]=ToDouble(GetPrm(T, 4, ';').c_str());    	// Tc
	  ch.E[ch.iP]=ToDouble(GetPrm(T, 5, ';').c_str());    	// E
	  ch.Ep[ch.iP]=ToDouble(GetPrm(T, 6, ';').c_str());		// E%
	  ch.P[ch.iP]=ToDouble(GetPrm(T, 7, ';').c_str());    	// P
	  ch.R[ch.iP]=ToDouble(GetPrm(T, 8, ';').c_str());    	// R
	  ch.UI[ch.iP]=ToDouble(GetPrm(T, 9, ';').c_str());   	// dI/dt
	  ch.UV[ch.iP]=ToDouble(GetPrm(T, 10, ';').c_str());  	// dV/dt
	  ch.UT[ch.iP]=ToDouble(GetPrm(T, 11, ';').c_str());  	// dT/dt
	  ch.iP++;
	  }
	fclose(sr);
	}
  }
ReShowAll();
}
//---------------------------------------------------------------------------


